{% extends "::base.html.twig" %}

{% block title %}CRM|Nuxiba{% endblock %}

{% block stylesheets %}
<link href="{{ asset('bundles/mdrcobranza/css/style.css') }}" rel="stylesheet">
<style type="text/css">
	#container-nuxiba
	{

	}
</style>
{% endblock %}
{% block javascripts %}
<script type="text/javascript" src="{{ asset('vendor/Nuxiba/APINuxiba.js') }}" /></script>
<script type="text/javascript" src="{{ asset('bundles/mdrpuntoventa/js/nuxibaCalls.js') }}"></script>
<script type="text/javascript" src="{{ asset('bundles/mdrpuntoventa/js/nuxibaCallsViews.js') }}"></script>
<script type="text/javascript">
	var maxDigitosTelCliente = {{ maxDigitosTelCliente }};
	var indexCall = 0;
	var nuxibaView = null;

	var btnLlamadaActiva = null;

	//Simular llamada
	var btnSimular = null;
	var inputsimulaDnis = null;
	var inputsimulaNumCliente = null;
	
	window.onbeforeunload = validarSalida;
	window.onunload = function(){
		localStorage.setItem("conexionNuxibaOpen", 0);
	}
	
	document.addEventListener("DOMContentLoaded", function(){
		if(localStorage.getItem("conexionNuxibaOpen") == 1)
		{
			window.onunload = null;
			window.onbeforeunload = null;
			$("#mainContainer").html("");
			window.close();
		}
		else
		{
			localStorage.setItem("conexionNuxibaOpen", 1);
			Nuxiba.init(JavaScriptPackageRemote);
			Nuxiba.events.onCallRecieved.push(callReceived);
			Nuxiba.events.onCallHistory.push(callHistoryReceived);

			nuxibaView = new NuxibaView();

			btnLlamadaActiva 		= document.getElementById("btnLlamadaActiva");

			//Simular llamada
			inputsimulaDnis 		= document.getElementById("simulaDnis");
			inputsimulaNumCliente	= document.getElementById("simulaNumCliente");
			btnSimular 				= document.getElementById("btnSimular");

			if(btnSimular != null)
				btnSimular.addEventListener("click", simular);
			btnLlamadaActiva.addEventListener("click", llamadaActiva);
		}
	});

	function simular()
	{
		var data = []
		data.DNIS 			= inputsimulaDnis.value.trim();
		data.phoneNumber 	= inputsimulaNumCliente.value.trim();
		data.esEntrante 	= 1;
		data.call_id 		= '';
		callReceived(data);
	}

	function callReceived(nuxibaData)
	{
		var data = convertNuxibaCall(nuxibaData);
		nuxibaCalls.create(data);
		while(nuxibaCalls.length > 10)
		{
			nuxibaCalls.at(0).destroy();
		}
	}

	function convertNuxibaCall(nuxibaData)
	{
		var data = {DNIS: "", phoneNumber: "", esEntrante: 0, callId: 0};
		data.DNIS = '';
		data.esEntrante = nuxibaData.typeCall == 1 ? 1 : 0;
		data.phoneNumber = nuxibaData.phoneNumber;
		if(data.phoneNumber.length > maxDigitosTelCliente)
		{
			data.phoneNumber = data.phoneNumber.substr(data.phoneNumber.length - maxDigitosTelCliente, maxDigitosTelCliente);
		}
		try
		{
			if(nuxibaData.DNIS.length > 0)
			{
				data.DNIS = nuxibaData.DNIS;
			}
			else if(nuxibaData.contactData)
			{
				if(nuxibaData.contactData.length > 0)
				{
					data.DNIS = nuxibaData.contactData[0];
				}
			}
		}
		catch(err) {
		    console.log(err);
		}

		if(nuxibaData.call_id != undefined)
		{
			data.callId = nuxibaData.call_id;
		}

		return data;
	}

	function addStorage(data)
	{
		if(data != null)
		{
			if(data.phoneNumber.length > maxDigitosTelCliente)
			{
				data.phoneNumber = data.phoneNumber.substr(data.phoneNumber.length - maxDigitosTelCliente, maxDigitosTelCliente);
			}
			if(nuxibaCalls.length > 0)
			{
				var telefono = quitarLada(data.phoneNumber);
				if(quitarLada(nuxibaCalls.at(nuxibaCalls.length-1).get("phoneNumber")) != telefono)
				{
					nuxibaCalls.create(data);
				}
			}
			else
			{
				nuxibaCalls.create(data);
			}
		}
	}

	function setLlamadaStorage(data)
	{
		localStorage.setItem("nuxibaRetCall", "");
		if(data != null)
		{
			localStorage.setItem("nuxibaRetCall", JSON.stringify(data));
		}
	}

	function llamadaActiva()
	{
		var call = Nuxiba.GetLastCallData();
		
		if(call != null)
		{
			var data = {};
			data.DNIS = '';
			data.phoneNumber = call.phoneNumber;
			data.esEntrante = call.typeCall == 1 ? 1 : 0;
			if(call.contactData)
			{
				if(call.contactData.length > 0)
				{
					data.DNIS = call.contactData[0];
				}
			}
			addStorage(data);
			setLlamadaStorage(data);
		}
		else if(Nuxiba.getAgentID() > 0)
		{
			Nuxiba.getCallHistory();
		}
	}

	function getLastCall()
	{
		var nuxibaData = null;
		var data = null;
		var call = null;
		var dataJSON ="";

		try
		{
			nuxibaData = Nuxiba.GetLastCallData();
		}
		catch(err) {
		}

		if(nuxibaData != null)
		{
			data = convertNuxibaCall(nuxibaData);
			call = nuxibaCalls.byCallId(data.callId);
			if(call != null)
			{
				data = call.toJSON();
			}
		}
		else
		{
			if(nuxibaCalls.length > 0)
			{
				data = nuxibaCalls.at(1).toJSON();
			}
		}

		setLlamadaStorage(data);
	}

	function getPreLastCall()
	{
		Nuxiba.getCallHistory();
	}

	function callHistoryReceived(calls)
	{
		var data = null;
		var dataJSON = "";
		indexCall = 0;
		if(calls != null && calls.length > indexCall)
		{
			data = {};
			data.DNIS = '';
			data.phoneNumber = calls[indexCall].telephone;
			data.esEntrante = calls[indexCall].type == 'IN' ? 1 : 0;
		}
		addStorage(data);
		setLlamadaStorage(data);
	}

</script>
{% endblock %}

{% block body %}
<script type="text/javascript" src="{{ asset('vendor/Nuxiba/FlashVersion.js') }}" /></script>

<div id="mainContainer" class="container generalContainer">
<h1>Conexión Nuxiba</h1>
	<div id="container-nuxiba">
		<div class="row">
			<div class="col-xs-5">
				<script language="JavaScript" type="text/javascript">
					AC_FL_RunContent(
						'codebase', 'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=10,0,0,0',
						'width', '510',
						'height', '40',
						'src', '{{ asset('vendor/Nuxiba/JavaScriptPackageRemote') }}',
						'quality', 'best',
						'pluginspage', 'http://www.adobe.com/go/getflashplayer',
						'align', 'middle',
						'play', 'true',
						'loop', 'true',
						'scale', 'showall',
						'wmode', 'opaque',
						'devicefont', 'false',
						'id', 'JavaScriptPackageRemote',
						'bgcolor', '#ffffff',
						'name', 'JavaScriptPackageRemote',
						'menu', 'true',
						'allowFullScreen', 'false',
						'allowScriptAccess','sameDomain',
						'movie', '{{ asset('vendor/Nuxiba/JavaScriptPackageRemote') }}',
						'salign', ''
						); //end AC code
				</script>
				<noscript>
					<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=10,0,0,0" width="510" height="45" id="JavaScriptPackageRemote" align="middle">
						<param name="allowScriptAccess" value="always" />
						<param name="allowFullScreen" value="false" />
						<param name="movie" value="JavaScriptPackageRemote.swf" /><param name="quality" value="best" /><param name="wmode" value="opaque" /><param name="bgcolor" value="#ffffff" />	
						<embed src="{{ asset('vendor/Nuxiba/JavaScriptPackageRemote.swf') }}" quality="best" wmode="opaque" bgcolor="#ffffff" width="510" height="45" name="JavaScriptPackageRemote" align="middle" allowScriptAccess="always" allowFullScreen="false" type="application/x-shockwave-flash" pluginspage="http://www.adobe.com/go/getflashplayer" />
					</object>
				</noscript>
			</div>
			<div class="col-xs-4">
				{% if env == 'Dev' %}
				<div class="panel panel-default" style="margin-bottom: 0;">
					<div class="panel-body" style=" padding-top: 5px; padding-bottom: 5px; ">
						<div class="row">
							<div class="col-xs-2">
								<label>DNIS: </label>
							</div>
							<div class="col-xs-6">
								<input type="text" id="simulaDnis" name="simulaDnis" maxlength="20" tabindex="1" />
							</div>
							<div class="col-xs-2">
								<button id="btnSimular" tabindex="3">Simular</button>
							</div>
						</div>
						<div class="row">
							<div class="col-xs-2">
								<label>Número: </label>
							</div>
							<div class="col-xs-6">
								<input type="text" id="simulaNumCliente" name="simulaNumCliente" maxlength="20" tabindex="3" />
							</div>
						</div>
					</div>
				</div>
				{% endif %}
			</div>
			<div class="col-xs-2">
				<button class="btn btn-info" id="btnLlamadaActiva">Tomar Activa/Última</button>
			</div>
		</div>
  	</div>
    <br/>
	<div class="table-container-seleccionados">
		<table class="table table-bordered table-striped table-condensed">
			<thead>
				<tr>
					<th>DNIS</th>
					<th>Cliente</th>
					<th>Tipo</th>
					<th>Call Id</th>
					<th></th>
				</tr>
			</thead>
			<tbody class="nuxibaCalls"></tbody>
		</table>
	</div>
</div>

<script type="text/template" id='nuxibaCallTemplate'>
	<td><%= DNIS %></td>
	<td><%= phoneNumber %></td>
	<td><%= esEntrante == 1 ? 'In' : 'Out' %></td>
	<td><%= callId %></td>
	<td>
		<button class="btn btn-info btn-xs tomar" onclick="return false">Tomar</button>
	</td>
</script>
{% endblock %}